<template>
  <v-container>
    <v-row justify="space-between">
      <v-col cols="12" md="5">
        <p class="page-title">
          Información de la compañía
        </p>
      </v-col>
    </v-row>
    <v-card outlined class="mx-auto" max-width="100%">
      <v-card-subtitle class="pb-0">
        <image-field
          v-model="newClientCompany.multipartFile"
          :disabled="disabledInformation"
        />

        <v-divider />
        <v-form ref="newEntityForm" class="mt-8" lazy-validation>
          <register-field-validation
            v-model="newClientCompany.ruc"
            field-name="RUC"
            :validation="rucRules"
            place-holder="Ingrese RUC"
            @inputChange="changeRUC"
          />
          <register-field-validation
            v-model="newClientCompany.name"
            :disabled="true"
            field-name="Razón Social"
            place-holder="Ingrese Razón Social"
          />
          <register-field-validation
            v-model="newClientCompany.email"
            :disabled="disabledInformation"
            field-name="Correo Electrónico"
            :validation="emailRules"
            place-holder="Ingrese Correo"
          />
          <register-field-validation
            v-model="newClientCompany.phone"
            :disabled="disabledInformation"
            field-name="Número de Teléfono"
            :validation="phoneRules"
            place-holder="Ingrese Número de Teléfono"
            :obligatory="false"
          />
          <directions-field
            v-model="newClientCompany.address"
            :disabled="disabledInformation"
            field-name="Dirección"
            :validation="addressRules"
            place-holder="Ingrese Dirección"
          />
        </v-form>
      </v-card-subtitle>
      <v-card-actions class="d-flex justify-end">
        <v-btn class="buttonRegisterLeft" color="white" large rounded @click="handleCancelRegister()">
          CANCELAR
        </v-btn>
        <register-button
          class="buttonRegisterLeft"
          button-name="CONTINUAR"
          :outlined="false"
          @clicked="clickButton()"
        />
      </v-card-actions>
      <br>
      <v-snackbar v-model="snackBar.show" :color="snackBar.color" text top>
        {{ snackBar.text }}
        <template #action="{ attrs }">
          <v-btn color="blue" text v-bind="attrs" @click="snackBar.show = false">
            <v-icon>mdi-window-close</v-icon>
          </v-btn>
        </template>
      </v-snackbar>
    </v-card>
  </v-container>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import RegisterImage from '~/components/register/registerImage';
import RegisterButton from '~/components/register/registerButton';
import { rucRules, companyNameRules, emailRules, phoneRules, addressRules } from '~/helpers/validation';
import ImageField from '~/components/InputField/ImageField';
import RegisterFieldValidation from '~/components/InputField/RegisterFieldValidation';
import DirectionsField from '~/components/InputField/DirectionsField';

export default {
  name: 'RegisterClients',
  components: {
    RegisterButton,
    RegisterImage,
    DirectionsField,
    RegisterFieldValidation,
    ImageField,
  },
  data() {
    return {
      disabledInformation: true,
      disabledName: true,
      rucRules,
      companyNameRules,
      emailRules,
      phoneRules,
      addressRules,
      newClientCompany: {
        address: '',
        name: '',
        phone: '',
        ruc: '',
        multipartFile: null,
        email: '',
      },
      isClientRegistered: false,
      snackBar: {
        show: false,
        color: '',
        text: '',
      },
    };
  },
  computed: {
    ...mapState({
      checkedClientCompany: state => state.providercompany['client-company'].checkedClientCompany,
    }),
  },

  methods: {
    ...mapActions({
      // getCompanies: 'providercompany/client-company/getClientCompanies',
      registerClientCompany: 'providercompany/client-company/registerClientCompany',
      checkedInformationClientCompany: 'providercompany/client-company/checkedInformationClientCompany',
      storeNewClientCompany: 'providercompany/client-company/storeNewClientCompany',
    }),
    async changeRUC(valid) {
      if (valid) {
        const checkedClientCompany = await this.checkedInformationClientCompany(this.newClientCompany.ruc);
        this.checkedCompany(checkedClientCompany.data);
      } else {
        this.disabled_user_info = true;
        this.disabled_specialist_info = true;
      }
    },
    checkedCompany(clientCompany) {
      this.clearForm();
      if (clientCompany.isRegistered) {
        this.isClientRegistered = true;
        this.newClientCompany = clientCompany.clientCompany;
        this.setNackBar('CAMBIAR RUC. Existe una compañía cliente registrada con el RUC ingresado', 'error', true);
      }
      if (clientCompany.companyApi) {
        this.newClientCompany.name = clientCompany.companyApi.nombre;
        this.disabledInformation = false;
        this.setNackBar('RUC válido, complete los demás campos', 'primary', true);
      }
      if (!clientCompany.isRegistered && !clientCompany.companyApi) {
        this.setNackBar('RUC INCORRECTO', 'error', true);
      }
    },
    handleCancelRegister() {
      this.$router.push('/clientes');
    },
    setNackBar(text, color, show) {
      this.snackBar.text = text;
      this.snackBar.show = show;
      this.snackBar.color = color;
    },
    async clickButton() {
      if (!this.isClientRegistered) {
        if (this.$refs.newEntityForm.validate()) {
        // FIRST store information client comany in file store.
          const copia = Object.assign({}, this.newClientCompany);
          await this.storeNewClientCompany(copia);
          // Then emit an event to go to step2.
          this.$emit('clickButton');
        }
      } else {
        this.setNackBar('CAMBIAR RUC. Existe una compañía cliente registrada con el RUC ingresado', 'error', true);
      }
    },
    clearForm() {
      this.newClientCompany.name = '';
      this.newClientCompany.address = '';
      this.newClientCompany.phone = '';
      this.newClientCompany.email = '';
    },
  },
};
</script>

<style scoped>
.page-title {
  font-family: 'Montserrat', sans-serif;
  font-size: 1.5rem;
  margin-top: 1rem;
  margin-left: 1rem;
}
.buttonRegisterLeft {
  margin-top: 1rem;
}
</style>
